/*
    fsetup.cpp


    flexemu, an MC6809 emulator running FLEX
    Copyright (C) 1997-2003  W. Schwotzer
	 
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include <misc1.h>


// For compilers that support precompilation, includes "wx.h".
#include <wx/wxprec.h>

#ifdef __BORLANDC__
#pragma hdrstop
#endif

#ifndef WX_PRECOMP
// Include your minimal set of headers here, or wx.h
#include <wx/wx.h>
#endif
#include <wx/resource.h>

#include "fsetpdlg.h"
#include "fsetup.h"

#ifdef __WXMSW__
static char *fsetupResource = NULL;
#else
#include "fsetup.wxr"
#endif


IMPLEMENT_APP(FlexemuSetup)

/*------------------------------------------------------
 flexemuSetup implementation (The Application class)
--------------------------------------------------------*/
bool FlexemuSetup::OnInit(void)
{
	dialog = NULL;
	// parse resource data
#ifdef __WXMSW__
	fsetupResource = wxLoadUserResource("fsetupResource", "WXRDATA");
	wxResourceParseString(fsetupResource);
	delete fsetupResource;
	fsetupResource = NULL;
#else
	wxResourceParseData(flexemuOptionsDialog);
#endif

	optionMan.InitOptions(&guiOptions, &options, argc, argv);
	optionMan.GetOptions(&guiOptions, &options);
	optionMan.GetEnvironmentOptions(&guiOptions, &options);
	SetAppName("FlexemuSetup");
	dialog = new FlexemuOptionsDialog(&guiOptions, &options);
	dialog->SetModal(false);
	if (dialog->LoadFromResource((wxWindow *)NULL, "flexemuOptionsDialog")) {
		dialog->Show(true);
		SetTopWindow(dialog);
		return TRUE;
	}
	return FALSE;
}

int FlexemuSetup::OnExit(void)
{
	if (GetReturnCode() == wxID_OK)
		optionMan.WriteOptions(&guiOptions, &options);

	return 1;
}

